// Mark Kamichoff
// kamicm@rpi.edu
// Homework #3

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>

#define INIT_W 480
#define INIT_H 480
#define PI 3.141592654

void myinit(void);
void myReshape(GLsizei, GLsizei);
void key(unsigned char, int, int);
void tdrect(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
void stardestroyer(float);
void tiefighter(float);

// globals
GLfloat win_width, win_height;
GLUquadricObj* gluObj;

// Lights
int lite0 = -1;
int lite1 = -1;
int lite2 = -1;
int lite3 = -1;

// Sizes
float s_size = 0.5;
float t_size = 2;

// misc -1 is keyb, 1 is mouse
int howrotate = -1;

// View Stuff
int btempx, btempy, bktempx, bktempy, btemprotatespeed;
GLfloat tempx = 0.0;
GLfloat tempy = 0.0;
GLfloat ktempx = 5.0;
GLfloat ktempy = 5.0;

// Star destroyer position
int bstranslate, bsangle, bypos;
GLfloat sangle = 0.0;
GLfloat xpos = 0.0;
GLfloat ypos = 0.0;
GLfloat zpos = 0.0;

GLfloat tiex = 0.0;
GLfloat tiey = 0.0;
GLfloat tiez = 0.0;

// Rotate stuff
GLfloat temprotate = 0.0;
GLfloat temprotatespeed = 0.3;

// Main display function
void display(void)
{
//	GLfloat mat_amb_diff_0[] = { 1.0, 0.1, 0.1, 1.0};	// Sphere
	GLfloat mat_amb_diff_1[] = { 0.2, 0.2, 0.2, 1.0};	// Ship

	// Moves the whole scene
	if(bktempx == -1) ktempx--;
	if(bktempx == 1) ktempx++;
	if(bktempy == 1) ktempy++;
	if(bktempy == -1) ktempy--;
	if(bypos == 1) ypos += 0.01;
	if(bypos == -1) ypos -= 0.01;

	// Moves the star destroyer
	if(bsangle == 1) sangle += 1;
	if(bsangle == -1) sangle -= 1;
	if(btemprotatespeed == 1) temprotatespeed += 0.1;
	if(btemprotatespeed == -1) temprotatespeed -= 0.1;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// Mouse
	if(howrotate == 1)
	{
		glRotatef(tempx, 0.0, 1.0, 0.0);
		glRotatef(tempy, 1.0, 0.0, 0.0);
	}
	// Keyboard
	else
	{
		glRotatef(ktempx, 0.0, 1.0, 0.0);
		glRotatef(ktempy, 1.0, 0.0, 0.0);
	}

	// The tie fighters follow the star destroyer slowly...
	if(tiex!=xpos || tiey!=ypos || tiez!=zpos)
	{
		tiex += (xpos-tiex)/112;
		tiey += (ypos-tiey)/112;
		tiez += (zpos-tiez)/112;
	}

	// Rotate the tie fighters sync'ed
	temprotate += temprotatespeed;

	// Do some angle/vector calculations
	if(bstranslate == 1)
	{
		xpos += cos(PI*((int)sangle%360)/180) * 0.01;
		zpos += sin(PI*((int)sangle%360)/180) * 0.01;

//		printf("(%f, %f, %f) @%d\n", xpos, ypos, zpos, (int)sangle%360);
	}
	else if(bstranslate == -1)
	{
		xpos -= cos(PI*((int)sangle%360)/180) * 0.01;
		zpos -= sin(PI*((int)sangle%360)/180) * 0.01;
	}

	// Star destroyer
	glPushMatrix();
		glTranslatef(xpos, ypos, zpos);
		glRotatef(-sangle+90, 0.0, 1.0, 0.0);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_amb_diff_1);
		stardestroyer(s_size);
	glPopMatrix();

	// 3x Tie fighters circling it...
	glPushMatrix();
		glTranslatef(tiex, tiey, tiez);
		glRotatef(-temprotate, 0.0, 1.0, 0.0);
		glTranslatef(0.6, 0.0, 0.0);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_amb_diff_1);
		tiefighter(t_size);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(tiex, tiey, tiez);
		glRotatef(temprotate, 1.0, 0.0, 0.0);
		glTranslatef(0.0, 0.6, 0.0);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_amb_diff_1);
		tiefighter(t_size);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(tiex, tiey, tiez);
		glRotatef(-temprotate, 0.0, 0.0, 1.0);
		glTranslatef(-0.6, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		glRotatef(-90, 1.0, 0.0, 0.0);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_amb_diff_1);
		tiefighter(t_size);
	glPopMatrix();

	glutSwapBuffers();
}

// generic resize function, scales to W x H
void myReshape(GLsizei w, GLsizei h)
{
	win_width = w;
	win_height = h;

	glViewport(0,0,win_width,win_height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -10.0, 10.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glClearColor(0.0, 0.0, 0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT);

	display();
	glutSwapBuffers();
}

// generic initialization routine
void myinit(void)
{
	GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat mat_shininess[] = { 8.0 };

	// Set up all the light properties and positions
	GLfloat light0_ambient[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat light0_position[] = { 0.0, 1.0, 0.0, 0.0 };

	GLfloat light1_ambient[] = { 0.0, 0.0, 1.0, 1.0 };
	GLfloat light1_position[] = { 1.0, 0.0, 0.0, 0.0 };
	GLfloat light1_diffuse[] = { 0.0, 0.0, 1.0, 1.0 };

	GLfloat light2_ambient[] = { 1.0, 0.0, 0.0, 1.0 };
	GLfloat light2_position[] = { -1.0, 0.0, 0.0, 0.0 };
	GLfloat light2_diffuse[] = { 1.0, 0.0, 0.0, 1.0 };

	GLfloat light3_ambient[] = { 0.0, 1.0, 0.0, 1.0 };
	GLfloat light3_position[] = { 0.0, -1.0, 0.0, 0.0 };
	GLfloat light3_diffuse[] = { 0.0, 1.0, 0.0, 1.0 };

	// Make a new quadric object which we will use
	gluObj = gluNewQuadric();

	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_SMOOTH);
	
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

	// Apply the properties to the lights
	glLightfv(GL_LIGHT0, GL_AMBIENT, light0_ambient);
	glLightfv(GL_LIGHT0, GL_POSITION, light0_position);

	glLightfv(GL_LIGHT1, GL_AMBIENT, light1_ambient);
	glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
	glLightfv(GL_LIGHT2, GL_AMBIENT, light2_ambient);
	glLightfv(GL_LIGHT2, GL_POSITION, light2_position);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, light2_diffuse);
	glLightfv(GL_LIGHT3, GL_AMBIENT, light3_ambient);
	glLightfv(GL_LIGHT3, GL_POSITION, light3_position);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, light3_diffuse);

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);

	glutSwapBuffers();
}

void root_menu(int id)
{
	// Dummy Function
	if(id == 1)
		exit(0);
}

// If we type a key on the keyboad
void key(unsigned char k, int x, int y)
{
	// Keybindings
	if(k == 'q') exit(0);

	if(k == 'r') howrotate *= -1;

	if(k == 'h') bsangle = -1;
	if(k == 'l') bsangle = 1;
	if(k == 'j') bstranslate = -1;
	if(k == 'k') bstranslate = 1;

	if(k == 'a') bypos = 1;
	if(k == 'z') bypos = -1;

	if(k == '0') { xpos = ypos = zpos = 0; }
}

// Keybindings for ones that turn off when unpressed
void keyup(unsigned char k, int x, int y)
{
	if(k == 'h') bsangle = 0;
	if(k == 'l') bsangle = 0;
	if(k == 'j') bstranslate = 0;
	if(k == 'k') bstranslate = 0;

	if(k == 'a') bypos = 0;
	if(k == 'z') bypos = 0;
}

// special keys
void skey(unsigned char k, int x, int y)
{
	if(k == GLUT_KEY_LEFT) bktempx = -1;
	if(k == GLUT_KEY_RIGHT) bktempx = 1;
	if(k == GLUT_KEY_UP) bktempy = 1;
	if(k == GLUT_KEY_DOWN) bktempy = -1;
	if(k == GLUT_KEY_PAGE_UP) btemprotatespeed = 1;
	if(k == GLUT_KEY_PAGE_DOWN) btemprotatespeed = -1;

	// bunch of Fx keys toggle lights
	if(k == GLUT_KEY_F1)
	{
		if(lite0 == 1)
		{
			glDisable(GL_LIGHT0);
			lite0 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT0);
			lite0 *= -1;
		}
	}
	if(k == GLUT_KEY_F2)
	{
		if(lite1 == 1)
		{
			glDisable(GL_LIGHT1);
			lite1 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT1);
			lite1 *= -1;
		}
	}
	if(k == GLUT_KEY_F3)
	{
		if(lite2 == 1)
		{
			glDisable(GL_LIGHT2);
			lite2 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT2);
			lite2 *= -1;
		}
	}
	if(k == GLUT_KEY_F4)
	{
		if(lite3 == 1)
		{
			glDisable(GL_LIGHT3);
			lite3 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT3);
			lite3 *= -1;
		}
	}

	if(k == GLUT_KEY_F5) t_size += 0.1;
	if(k == GLUT_KEY_F6) t_size -= 0.1;
	if(k == GLUT_KEY_F7) s_size += 0.1;
	if(k == GLUT_KEY_F8) s_size -= 0.1;
}

// Up versions of the above bindings
void skeyup(unsigned char k, int x, int y)
{
	if(k == GLUT_KEY_LEFT) bktempx = 0;
	if(k == GLUT_KEY_RIGHT) bktempx = 0;
	if(k == GLUT_KEY_UP) bktempy = 0;
	if(k == GLUT_KEY_DOWN) bktempy = 0;
	if(k == GLUT_KEY_PAGE_UP) btemprotatespeed = 0;
	if(k == GLUT_KEY_PAGE_DOWN) btemprotatespeed = 0;
}

// Passive mouse...same as in last project
void mouse_passive(int x, int y)
{
	y = win_height - y;

	tempx = x;
	tempy = y;
}

// Main function
int main(int argc, char **argv)
{
	// Sets the global h/w
	win_width = INIT_W;
	win_height = INIT_H;
		
	// GLUT stuff and create the menus
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(INIT_W, INIT_H);
	glutCreateWindow("Prolixium Ships");

	glutDisplayFunc(display);
	glutIdleFunc(display);

	glutCreateMenu(root_menu);
	glutCreateMenu(root_menu);
	glutAddMenuEntry("The Dark Side...(Exits)", 1);

	// right click for the menu
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	myinit();

	glutReshapeFunc(myReshape);

	glutIgnoreKeyRepeat(1);
	glutKeyboardFunc(key);
	glutKeyboardUpFunc(keyup);
	glutSpecialFunc((void *)skey);
	glutSpecialUpFunc((void *)skeyup);
	glutPassiveMotionFunc(mouse_passive);

	glutMainLoop();

	return 0;
}
